package dtf.core;
import stamp.core.*;
import dtf.core.*;

public class memkey
{
  static private Uart tomemkey;
  static private Uart frommemkey;
  static final int readbuffer = 0x00;
  static final int readnumkeys = 0x01;
  static final int prgtypematic = 0x02;
  static final int readtypematic = 0x03;
  static final int prgdebounce = 0x04;
  static final int readdebounce = 0x05;
  static final int prgrowncolumn = 0x06;
  static final int readrowncolumn = 0x07;
  static final int prgeeprom = 0x08;
  static final int readeeprom = 0x09;
  static final int prgserialkey = 0x0A;
  static final int readserialkey = 0x0B;
  static final int prgPCAT = 0x0C;
  static final int readPCAT = 0x0D;
  static final int prgconfig = 0x0E;
  static final int readconfig = 0x0F;
  static final int testmode = 0x10;
  static final int reset = 0x11;

/////////////////////////////////////////////////////////////////////

  static int print;
  static boolean stop = false;
  static StringBuffer hold = new StringBuffer();
  static StringBuffer temp = new StringBuffer();
  static private Uart toLCD;

  public memkey(Uart tomemkey, Uart frommemkey, Uart toLCD)
  {
    this.tomemkey = tomemkey;
    this.frommemkey = frommemkey;
    this.toLCD = toLCD;
  }

  public boolean keytest()
  {
    tomemkey.sendByte(readnumkeys);
    int numkeys = frommemkey.receiveByte();
    if (numkeys > 0)
    {
      return true;
    }
    else
    {
      return false;
    }
  }


  public void writekey(int key, int value)
  {
    tomemkey.sendByte(prgserialkey);
    CPU.delay(1000);
    tomemkey.sendByte(key);
    CPU.delay(1000);
    tomemkey.sendByte(value);
    CPU.delay(1000);
    tomemkey.sendByte(readserialkey);
    CPU.delay(1000);
    tomemkey.sendByte(key);
    int test = frommemkey.receiveByte();
    System.out.println(test);
  }


  public StringBuffer readbuffer()
  {
    SerialLCD LCD = new SerialLCD(toLCD);
    hold.clear();

    while(true)
    {
      print = read1buffer();
      if (print == -4)
      {
        break;
      }
      if (print == -2)
      {
        hold.delete((hold.length()-1), (hold.length()));
        LCD.clearScr();
        LCD.write(hold);
        print = getletter();
      }
      if (print == -3)
      {
        hold.clear();
        LCD.clearScr();
        LCD.write(hold);
        print = getletter();
      }
      if (print >= 0)
      {
        hold.append(print);
        LCD.clearScr();
        LCD.write(hold);
      }
    }
    LCD.clearScr();
    LCD.line2();
    LCD.write(hold);
    return hold;
  }



  public int read1buffer()
  {
    int answer = 0;
    tomemkey.sendByte(readbuffer);
    answer = frommemkey.receiveByte();
    if (answer == -1)
    {
      return -7;
    }
    return translate(answer);
  }

  public int translate(int answer)
  {
      if (answer == 10)
      {answer = -1;}
      if (answer == 11)
      {answer = -2;}
      if (answer == 12)
      {answer = -3;}
      if (answer == 13)
      {answer = -5;}
      if (answer == 14)
      {answer = -6;}
      if (answer == 15)
      {answer = -4;}
      return answer;
  }

  public StringBuffer readletter()
  {
    SerialLCD LCD = new SerialLCD(toLCD);
    hold.clear();
    print = getletter();
    while(true)
    {
      CPU.delay(10);
      if (print == -4)
      {
        break;
      }
      if (print == -3)
      {
        hold.clear();
        LCD.clearScr();
        LCD.write(hold);
        print = getletter();
      }
      if (print == -2)
      {
        hold.delete((hold.length()), (hold.length() + 1));
        LCD.clearScr();
        LCD.write(hold);
        print = getletter();
      }
      if (print == -5)
      {
        hold.append(" ");
        LCD.clearScr();
        LCD.write(hold);
        print = getletter();
      }
      if (print >= 0)
      {
        if (print == 1)
        {
          hold.append("1");
          LCD.clearScr();
          LCD.write(hold);
          print = getletter();
        }
        if (print == 0)
        {
          hold.append("0");
          LCD.clearScr();
          LCD.write(hold);
          print = getletter();
        }
//////////////////////////////////////////////
//////////////////////////////////////////////
//////////////////////////////////////////////
        if (print == 2)
        {
          LCD.clearScr();
          LCD.write(hold);
          LCD.write("2");
          print = getletter();
          if (print == 2)
          {
            LCD.clearScr();
            LCD.write(hold);
            LCD.write("A");

            print = getletter();
            if (print == 2)
            {
              LCD.clearScr();
              LCD.write(hold);
              LCD.write("B");

              print = getletter();
              if (print == 2)
              {
                LCD.clearScr();
                LCD.write(hold);
                LCD.write("C");

                print = getletter();
                if (print != 2)
                {
                  hold.append("C");
                  LCD.clearScr();
                  LCD.write(hold);
                }
              }

              else
              {
                hold.append("B");
                LCD.clearScr();
                LCD.write(hold);
              }
            }
            else
            {
              hold.append("A");
              LCD.clearScr();
              LCD.write(hold);

            }
          }
          else
          {
            hold.append("2");
            LCD.clearScr();
            LCD.write(hold);

          }
        }
//////////////////////////////////////////////
        if (print == 3)
        {
          LCD.clearScr();
          LCD.write(hold);
          LCD.write("3");

          print = getletter();
          if (print == 3)
          {
            LCD.clearScr();
            LCD.write(hold);
            LCD.write("D");

            print = getletter();
            if (print == 3)
            {
              LCD.clearScr();
              LCD.write(hold);
              LCD.write("E");

              print = getletter();
              if (print == 3)
              {
                LCD.clearScr();
                LCD.write(hold);
                LCD.write("F");

                print = getletter();
                if (print !=3)
                {
                  hold.append("F");
                  LCD.clearScr();
                  LCD.write(hold);
                }
              }
              else
              {
                hold.append("E");
                LCD.clearScr();
                LCD.write(hold);
              }
            }
            else
            {
              hold.append("D");
              LCD.clearScr();
              LCD.write(hold);

            }
          }
          else
          {
            hold.append("3");
            LCD.clearScr();
            LCD.write(hold);

          }
        }
//////////////////////////////////////////////
        if (print == 4)
        {
          LCD.clearScr();
          LCD.write(hold);
          LCD.write("4");

          print = getletter();
          if (print == 4)
          {
            LCD.clearScr();
            LCD.write(hold);
            LCD.write("G");

            print = getletter();
            if (print == 4)
            {
              LCD.clearScr();
              LCD.write(hold);
              LCD.write("H");

              print = getletter();
              if (print == 4)
              {
                LCD.clearScr();
                LCD.write(hold);
                LCD.write("I");

                print = getletter();
                if (print !=4)
                {
                  hold.append("I");
                  LCD.clearScr();
                  LCD.write(hold);
                }
              }
              else
              {
                hold.append("H");
                LCD.clearScr();
                LCD.write(hold);
              }
            }
            else
            {
              hold.append("G");
              LCD.clearScr();
              LCD.write(hold);

            }
          }
          else
          {
            hold.append("4");
            LCD.clearScr();
            LCD.write(hold);

          }
        }
//////////////////////////////////////////////
        if (print == 5)
        {
          LCD.clearScr();
          LCD.write(hold);
          LCD.write("5");

          print = getletter();
          if (print == 5)
          {
            LCD.clearScr();
            LCD.write(hold);
            LCD.write("J");

            print = getletter();
            if (print == 5)
            {
              LCD.clearScr();
              LCD.write(hold);
              LCD.write("K");

              print = getletter();
              if (print == 5)
              {
                LCD.clearScr();
                LCD.write(hold);
                LCD.write("L");

                print = getletter();
                if (print !=5)
                {
                  hold.append("L");
                  LCD.clearScr();
                  LCD.write(hold);
                }
              }
              else
              {
                hold.append("K");
                LCD.clearScr();
                LCD.write(hold);
              }
            }
            else
            {
              hold.append("J");
              LCD.clearScr();
              LCD.write(hold);

            }
          }
          else
          {
            hold.append("5");
            LCD.clearScr();
            LCD.write(hold);

          }
        }
//////////////////////////////////////////////
        if (print == 6)
        {
          LCD.clearScr();
          LCD.write(hold);
          LCD.write("6");

          print = getletter();
          if (print == 6)
          {
            LCD.clearScr();
            LCD.write(hold);
            LCD.write("M");

            print = getletter();
            if (print == 6)
            {
              LCD.clearScr();
              LCD.write(hold);
              LCD.write("N");

              print = getletter();
              if (print == 6)
              {
                LCD.clearScr();
                LCD.write(hold);
                LCD.write("O");

                print = getletter();
                if (print !=6)
                {
                  hold.append("O");
                  LCD.clearScr();
                  LCD.write(hold);
                }
              }
              else
              {
                hold.append("N");
                LCD.clearScr();
                LCD.write(hold);
              }
            }
            else
            {
              hold.append("M");
              LCD.clearScr();
              LCD.write(hold);

            }
          }
          else
          {
            hold.append("6");
            LCD.clearScr();
            LCD.write(hold);

          }
        }
//////////////////////////////////////////////
        if (print == 7)
        {
          LCD.clearScr();
          LCD.write(hold);
          LCD.write("7");

          print = getletter();
          if (print == 7)
          {
            LCD.clearScr();
            LCD.write(hold);
            LCD.write("P");

            print = getletter();
            if (print == 7)
            {
              LCD.clearScr();
              LCD.write(hold);
              LCD.write("R");

              print = getletter();
              if (print == 7)
              {
                LCD.clearScr();
                LCD.write(hold);
                LCD.write("S");

                print = getletter();
                if (print !=7)
                {
                  hold.append("S");
                  LCD.clearScr();
                  LCD.write(hold);
                }
              }
              else
              {
                hold.append("R");
                LCD.clearScr();
                LCD.write(hold);
              }
            }
            else
            {
              hold.append("P");
              LCD.clearScr();
              LCD.write(hold);

            }
          }
          else
          {
            hold.append("7");
            LCD.clearScr();
            LCD.write(hold);

          }
        }
//////////////////////////////////////////////
        if (print == 8)
        {
          LCD.clearScr();
          LCD.write(hold);
          LCD.write("8");

          print = getletter();
          if (print == 8)
          {
            LCD.clearScr();
            LCD.write(hold);
            LCD.write("T");

            print = getletter();
            if (print == 8)
            {
              LCD.clearScr();
              LCD.write(hold);
              LCD.write("U");

              print = getletter();
              if (print == 8)
              {
                LCD.clearScr();
                LCD.write(hold);
                LCD.write("V");

                print = getletter();
                if (print !=8)
                {
                  hold.append("V");
                  LCD.clearScr();
                  LCD.write(hold);
                }
              }
              else
              {
                hold.append("U");
                LCD.clearScr();
                LCD.write(hold);
              }
            }
            else
            {
              hold.append("T");
              LCD.clearScr();
              LCD.write(hold);

            }
          }
          else
          {
            hold.append("8");
            LCD.clearScr();
            LCD.write(hold);

          }
        }
//////////////////////////////////////////////
        if (print == 9)
        {
          LCD.clearScr();
          LCD.write(hold);
          LCD.write("9");

          print = getletter();
          if (print == 9)
          {
            LCD.clearScr();
            LCD.write(hold);
            LCD.write("W");

            print = getletter();
            if (print == 9)
            {
              LCD.clearScr();
              LCD.write(hold);
              LCD.write("X");

              print = getletter();
              if (print == 9)
              {
                LCD.clearScr();
                LCD.write(hold);
                LCD.write("Y");

                print = getletter();
                if (print !=9)
                {
                  hold.append("Y");
                  LCD.clearScr();
                  LCD.write(hold);
                }
              }
              else
              {
                hold.append("X");
                LCD.clearScr();
                LCD.write(hold);
              }
            }
            else
            {
              hold.append("W");
              LCD.clearScr();
              LCD.write(hold);

            }
          }
          else
          {
            hold.append("9");
            LCD.clearScr();
            LCD.write(hold);

          }
        }

//////////////////////////////////////////////
//////////////////////////////////////////////
//////////////////////////////////////////////
      }
      else
      {
        print = getletter();
      }
    }
    LCD.clearScr();
    LCD.line2();
    LCD.write(hold);
    return hold;
  }

  public int getletter()
  {
    while(true)
    {
      int second = read1buffer();
      if (second >= -6)
      {
        return second;
      }
    }
  }

}