package dtf.core;
import stamp.core.*;
import dtf.core.*;

public class oldDTFtable {

  static protected motor MMBE;
  static protected I2C mem;
  static Int32 high = new Int32();
  static Int32 target = new Int32();
  static Int32 low = new Int32();
  static Int32 hi = new Int32();
  static Int32 lo = new Int32();
  static StringBuffer temp = new StringBuffer();

  public oldDTFtable(motor MMBE, I2C mem)
  {
    this.MMBE = MMBE;
    this.mem = mem;
  }

  public static void recall(Int32 target)
  {
    //System.out.println("Moving");
    int block = 0;
    int address = 0;
    while(true)
    {
      if (address == 252)
      {
        if (block == 6)
        {
          break;
        }
        address = 0;
        block ++;
      }
      high.set(mem.readstring(block, address, 6));
      if(target.equals(high))
      {
        address = address + 7;
        high.set(mem.readstring(block, address, 4));
        MMBE.oldresolver(high.low);
        break;
      }
      if(target.compare(high)<0)
      {
        address = address + 7;
        hi.set(mem.readstring(block, address, 4));
        address = address - 19;
        low.set(mem.readstring(block, address, 6));
        address = address + 7;
        lo.set(mem.readstring(block, address, 4));
        high.subtract(low);
        hi.subtract(lo);
        target.subtract(low);
        target.multiply(hi);
        target.divide(high);
        target.add(lo);
        MMBE.oldresolver(target.low);
        break;
      }
      address = address + 12;
    }
  }

   public static StringBuffer recall(int find)
  {
    target.set(find);
    int block = 0;
    int address = 7;
    while(true)
    {
      if (address == 259)
      {
        if (block == 6)
        {
          break;
        }
        address = 7;
        block ++;
      }
      high.set(mem.readstring(block, address, 4));
      if(target.equals(high))
      {
        address = address - 7;
        temp = mem.readstring(block, address, 6);
        break;
      }
      if(target.compare(high)<0)
      {
        address = address - 7;
        hi.set(mem.readstring(block, address, 4));

        address = address - 5;
        low.set(mem.readstring(block, address, 6));

        address = address - 7;
        lo.set(mem.readstring(block, address, 6));

        high.subtract(low);
        hi.subtract(lo);
        target.subtract(low);
        target.multiply(hi);
        target.divide(high);
        target.add(lo);
        temp = target.toBuffer();
        break;
      }
      address = address + 12;
    }
    return temp;
  }
}